#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_RankPointParam.h"
std::auto_ptr<Fish_RankPointParam> Fish_RankPointParam::msSingleton(nullptr);

int Fish_RankPointParam::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RankPointParamData* Fish_RankPointParam::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_RankPointParamData>& Fish_RankPointParam::GetMapData()
{
	return mMapData;
}

void Fish_RankPointParam::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_RankPointParam.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RankPointParamData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomID = element->IntAttribute("RoomID");
		data.mRankType = element->IntAttribute("RankType");
		data.mType = element->IntAttribute("Type");
		data.mThresholds = element->IntAttribute("Thresholds");
		data.maddition = element->IntAttribute("addition");
		data.mMax = element->IntAttribute("Max");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_RankPointParam Loaded. Load Data:%u", mMapData.size());
}

void Fish_RankPointParam::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_RankPointParam");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_RankPointParam");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_RankPointParamData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RoomID", data.mRoomID);
		LuaCfgHelper::readInt(L, "RankType", data.mRankType);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Thresholds", data.mThresholds);
		LuaCfgHelper::readInt(L, "addition", data.maddition);
		LuaCfgHelper::readInt(L, "Max", data.mMax);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_RankPointParam Loaded. Load Data:%u", mMapData.size());
}

void Fish_RankPointParam::Reload()
{
	mMapData.clear();
	Load();
}

Fish_RankPointParam* Fish_RankPointParam::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RankPointParam());
	}
	return msSingleton.get();
}

void Fish_RankPointParam::Release()
{
	msSingleton.reset(nullptr);
}
